From 7215215cd1101c3eed353e14a72a932e8f5c21f2 Mon Sep 17 00:00:00 2001
From: Wei xie <xiewei@linuxdeepin.com>
Date: Tue, 27 Mar 2018 14:00:07 +0800
Subject: [PATCH] winex11: Fix QQ/TIM deadlocked

X11DRV_WindowMessage handle WM_X11DRV_SET_CURSOR message will
owner win_data_section and wait loader_section(set_window_cursor
->create_cursor->create_xcursor_system_cursor->GetModuleHandleW),
if load FlashControl.dll in other thread(thread B), thread B will
CreateWindow in process_attach entry, so in thread B owner
loader_section and wait win_data_section.

Signed-off-by: Wei xie <xiewei@linuxdeepin.com>
---
 dlls/winex11.drv/window.c | 3 ++-
 1 file changed, 2 insertions(+), 1 deletion(-)

diff --git a/dlls/winex11.drv/window.c b/dlls/winex11.drv/window.c
index 34d59944e2..47f0e2bd98 100644
--- a/dlls/winex11.drv/window.c
+++ b/dlls/winex11.drv/window.c
@@ -2758,8 +2758,9 @@ LRESULT CDECL X11DRV_WindowMessage( HWND hwnd, UINT msg, WPARAM wp, LPARAM lp )
     case WM_X11DRV_SET_CURSOR:
         if ((data = get_win_data( hwnd )))
         {
-            if (data->whole_window) set_window_cursor( data->whole_window, (HCURSOR)lp );
+            Window win = data->whole_window;
             release_win_data( data );
+            if (win) set_window_cursor( win, (HCURSOR)lp );
         }
         else if (hwnd == x11drv_thread_data()->clip_hwnd)
             set_window_cursor( x11drv_thread_data()->clip_window, (HCURSOR)lp );
-- 
2.13.3

